// ComplexNumbers.h: interface for the CComplexNumbers class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMPLEXNUMBERS_H__EE395522_A64B_44C7_812F_7650FA1816FE__INCLUDED_)
#define AFX_COMPLEXNUMBERS_H__EE395522_A64B_44C7_812F_7650FA1816FE__INCLUDED_

#include <math.h>

class CComplexNumbers  
{
private:
	const double	r;		// Real part
	const double	i;		// Imaginary part

public:
	CComplexNumbers( double _r, double _i ) : r( _r ), i( _i ) {}
	virtual ~CComplexNumbers() {}

	CComplexNumbers	operator *( const CComplexNumbers& a );
	CComplexNumbers	operator +( const CComplexNumbers& a );

	double			Modulos();
};

inline CComplexNumbers CComplexNumbers::operator *( const CComplexNumbers& a )
{
	double r = ( this->r * a.r ) - ( this->i * a.i );
	double i = ( this->r * a.i ) + ( this->i * a.r );

	return CComplexNumbers( r, i );
}

inline CComplexNumbers CComplexNumbers::operator +( const CComplexNumbers& a )
{
	double r = this->r + a.r;
	double i = this->i + a.i;

	return CComplexNumbers( r, i );
}

inline double CComplexNumbers::Modulos()
{
	return sqrt( pow( r, 2 ) + pow( i, 2 ) );
}

#endif // !defined(AFX_COMPLEXNUMBERS_H__EE395522_A64B_44C7_812F_7650FA1816FE__INCLUDED_)
